
unit hiMST_UseEditCtrl;                                                                             

interface
     
uses Windows, Messages, Kol, Share, Debug, hiMTStrTbl;

const
  US_APP               = WM_APP + 1000;
  US_ESCCELL           = US_APP + 50;
  US_SETCELL           = US_APP + 51;  
  
const
  HDN_FIRST         = -300;           { Header }
  HDN_ITEMCHANGINGA = HDN_FIRST-0;
  HDN_ITEMCHANGEDA  = HDN_FIRST-1;
  HDN_TRACKA        = HDN_FIRST-8;
  HDN_ITEMCHANGINGW = HDN_FIRST-20;
  HDN_ITEMCHANGEDW  = HDN_FIRST - 21;
  HDN_TRACKW        = HDN_FIRST-28;  

type
  tagNMHEADERA = packed record
    Hdr: TNMHdr;
    Item: Integer;
    Button: Integer;
    PItem: PHDItemA;
  end;
  HD_NOTIFY = tagNMHEADERA;

type
  THIMST_UseEditCtrl = class(TDebug)
   private
     sControl: PControl;
     NewLine: integer;
     OldLine, OldCurIdx: integer;
     FMSTControl: IMSTControl;
     OldMessage: TOnMessage;
     CellRedaction: boolean;//test

     procedure SetMSTControl(Value: IMSTControl); 
     procedure MakeVisible(pRow, pCol: integer);
     procedure snewcuridx(value:integer);
     function gnewcuridx: integer;
     function Fredaction: boolean;
     function fctl3d: boolean;     
     function fwinstyle: integer;
   public

     _prop_KeyCellEnter: byte;
     _prop_DblClick: boolean;
     _prop_ShiftLeft: integer;
     _prop_ShiftTop: integer;
     _prop_AddWidth: integer;
     _prop_AddHeight: integer;
     _data_Row: THI_Event;
     _data_Col: THI_Event;
     _event_onEscCell: THI_Event;
     _event_onEnterCell: THI_Event;
     _event_onCellSize: THI_Event;
     _event_onClientRect: THI_Event;
     _event_onVisibleCell: THI_Event;          

     property _prop_MSTControl: IMSTControl read FMSTControl write SetMSTControl;
     property NewCurIdx:integer read gnewcuridx write snewcuridx;
     
     procedure _work_doSetData(var _Data: TData; Index: word);
     procedure _work_doSetCell(var _Data: TData; Index: word);//test
     procedure _work_doStop(var _Data: TData; Index: word);
     procedure _work_doClientRect(var _Data: TData; Index: word);     
     procedure _var_Index(var _Data: TData; Index: word);
     procedure _var_Cell(var _Data: TData; Index: word);
     procedure _var_SubItem(var _Data: TData; Index: word);
     procedure _var_Matrix(var _Data: TData; Index: word);
	 constructor Create;
   protected
     function _OnMessage(var Msg: TMsg; var Rslt: Integer): Boolean;   
  end;

implementation


//------------------------------------------------------------------------------
//
constructor THIMST_UseEditCtrl.Create;
begin
  inherited;
  NewLine := -1;
  CellRedaction := false;//test
end;

function THIMST_UseEditCtrl._OnMessage;
type
  TMouseDownPt = packed record
    X: Word;
    Y: Word;
  end;
var
  R, ARect: TRect;
  Pt: TMouseDownPt; 
  HTI: TLVHitTestInfo;
  Data: TData;
  mt: PMT;
  l: TListViewOptions;
  
  procedure InitOnEvent(Redaction: boolean);
  var
    b, s: integer;

	function ScrollBarWidth(Style : Longint) : integer;
	begin
	  Result := 0;
      if (GetWindowLong(sControl.Handle, GWL_STYLE) and Style) = 0 then exit;
      begin
        if Style = WS_VSCROLL then
          Result := GetSystemMetrics(SM_CXVSCROLL)
        else if Style = WS_HSCROLL then
          Result := GetSystemMetrics(SM_CYHSCROLL);
      end;
	end;

  begin
    R := sControl.LVSubItemRect(NewLine, NewCurIdx);
    if NewCurIdx = 0 then
    begin
      ARect := sControl.LVItemRect(NewLine, lvipLabel);
      R.Left := ARect.Left;
      R.Right := ARect.Right;
    end; 

	s := 0; b := 0;

    if fctl3d then
    begin
      case fwinstyle of
        0:
        begin
          s := 2; b := 3;
        end;
        1:
        begin
          s := 0; b := 1;
        end;
        2:
        begin
          s := 1; b := 2;
        end;
        3:
        begin
          s := 3; b := 4;
       end;
       4:
        begin
          s := 5; b := 6;
        end;
      end;
    end
    else
    begin
      s := 1; b := 1;
    end;

    if R.Left < sControl.Left then R.Left := sControl.Left - 1;
    dtInteger(Data, R.Left + sControl.Left + b + _prop_ShiftLeft);
    mt := mt_make(Data);
    mt_int(mt, R.Top + sControl.Top + s + _prop_ShiftTop);

    if (R.Right + b) >= sControl.Width - ScrollBarWidth(WS_VSCROLL) then  
      mt_int(mt, sControl.Width - R.Left - 2 * b + 1 + _prop_AddWidth - ScrollBarWidth(WS_VSCROLL))
	else
      mt_int(mt, R.Right - R.Left - 1 + _prop_AddWidth);

    if (R.Bottom + s) >= sControl.Height - ScrollBarWidth(WS_HSCROLL) then  
      mt_int(mt, sControl.Height - R.Top - 2 * s + _prop_AddHeight - ScrollBarWidth(WS_HSCROLL))
	else
      mt_int(mt, R.Bottom - R.Top - 1 + _prop_AddHeight);

    _hi_OnEvent_(_event_onCellSize, Data);
    mt_free(mt);

    if not Redaction then exit;
    CellRedaction := true;//test
    MakeVisible(NewLine, NewCurIdx);
    _hi_onEvent(_event_onEnterCell, sControl.LVItems[NewLine, NewCurIdx]);
  end;

  procedure EscCell;
  begin
    if not CellRedaction then 
    begin
      OldLine := NewLine;
      OldCurIdx := NewCurIdx;
    end;
    R := sControl.LVItemRect(OldLine, lvipBounds);
    ARect := sControl.LVItemRect(OldLine, lvipLabel);
    R.Left := ARect.Left;
    InvalidateRect(sControl.Handle, @R, false);
    if CellRedaction then
    begin
      CellRedaction := false;//test
      _hi_OnEvent(_event_onEscCell, sControl.LVItems[OldLine, OldCurIdx]);
      _hi_onEvent(_event_onVisibleCell, 0);
    end;
  end;
  
  function GetPositionStructure: boolean;
  begin
    Pt:= TMouseDownPt(Msg.lParam);
    HTI.pt.x := Pt.X;
    HTI.pt.y := Pt.Y;
    sControl.Perform( LVM_SUBITEMHITTEST, 0, Integer( @HTI ) );
    Result := (HTI.flags <> LVHT_ONITEMSTATEICON) and (HTI.iItem <> -1)
  end;

begin
  Result := false;
  if FRedaction then exit;

  l:= sControl.LVOptions;
  case Msg.message of
    WM_PAINT:
	begin
      InitOnEvent(false);
	  if CellRedaction then
        if ((NewLine < sControl.LVTopItem) or (NewLine >= sControl.LVTopItem + sControl.LVPerPage)) then
          _hi_onEvent(_event_onVisibleCell, 0)
        else
          _hi_onEvent(_event_onVisibleCell, 1);
	end;
    WM_NOTIFY:
      if (HD_NOTIFY(Pointer(Msg.LParam)^).Hdr.code = HDN_ITEMCHANGEDA) or
         (HD_NOTIFY(Pointer(Msg.LParam)^).Hdr.code = HDN_ITEMCHANGEDW) then
        InitOnEvent(false);
    WM_RBUTTONDOWN, WM_LBUTTONDOWN:
    begin
      if GetPositionStructure then
      begin 
        NewLine := HTI.iItem;
        NewCurIdx := HTI.iSubItem;             
      end;
      EscCell;
    end;
    WM_LBUTTONDBLCLK:
    begin
      if GetPositionStructure and _prop_DblClick then
      begin
        OldLine := NewLine;
        OldCurIdx := NewCurIdx;
        InitOnEvent(true);
      end;  
    end;
    WM_SIZE:
	begin
	  if NewLine = -1 then exit;
      InitOnEvent(false);
	end;
    US_SETCELL://test
	  InitOnEvent(true);
	US_ESCCELL:
      EscCell;
    WM_KEYDOWN:
    begin
      Case Msg.WParam of
        VK_LEFT, VK_RIGHT:
        begin
          if (lvoRowSelect in l) then
          begin
            NewCurIdx := NewCurIdx + Msg.wParam - $26;
            if NewCurIdx >= sControl.LVColCount then
              NewCurIdx := sControl.LVColCount - 1
            else if NewCurIdx < 0 then NewCurIdx := 0;
            EscCell;
          end;
        end;
        VK_UP, VK_DOWN:
        begin
          NewLine := NewLine + Msg.wParam - $27;
          if NewLine >= sControl.Count then
            NewLine := sControl.Count - 1
          else if NewLine < 0 then NewLine := 0;
          EscCell;
        end;
        VK_RETURN:
          if _prop_KeyCellEnter = 1 then
            InitOnEvent(true);
        VK_F2:
          InitOnEvent(true);
        VK_ESCAPE:
          EscCell;
      end;
    end;
  end;
  Result := Result or _hi_OnMessage(OldMessage, Msg, Rslt);
end;

procedure THIMST_UseEditCtrl.snewcuridx;
begin
  if not Assigned(_prop_MSTControl) then exit;
  _prop_MSTControl.setnewcuridx(value);  
end;

function THIMST_UseEditCtrl.gnewcuridx;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getnewcuridx  
  else
    Result := 0;
end;

function THIMST_UseEditCtrl.fredaction;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getfredaction  
  else
    Result := true;
end;

function THIMST_UseEditCtrl.fctl3d;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getfctl3d  
  else
    Result := true;
end;

function THIMST_UseEditCtrl.fwinstyle;
begin
  if Assigned(_prop_MSTControl) then
    Result := _prop_MSTControl.getwinstyle  
  else
    Result := 0;
end;

function ListView_GetSubItemRect(hwndLV: HWND; iItem, iSubItem: Integer; code: DWORD; prc: PRect): BOOL;
begin
  if prc <> nil then
  begin
    prc^.Top := iSubItem;
    prc^.Left := code;
  end;
  Result := BOOL(SendMessage(hwndLV, LVM_GETSUBITEMRECT, iItem, Longint(prc)));
end;

procedure THIMST_UseEditCtrl.MakeVisible;
var
  SI: TScrollInfo;
  SbInfo: TScrollBarInfo;
  pXShift, pYShift, pXSize, pYSize, pHeight: integer;
  pYPos: integer;
  bRect, pRect: TRect;
begin

  bRect.Top := pCol;
  bRect.Left := LVIR_BOUNDS;
  if SendMessage(sControl.Handle, LVM_GETSUBITEMRECT, pRow, Longint(@bRect)) = 0 then exit;;

  pRect.Top := pCol;
  pRect.Left := LVIR_LABEL;
  if SendMessage(sControl.Handle, LVM_GETSUBITEMRECT, pRow, Longint(@pRect)) = 0 then exit;;


  pRect.Left := bRect.Left;
  pHeight := pRect.Bottom - pRect.Top;

  SI.cbSize := Sizeof(SI);
  SI.fMask := SIF_ALL;
  GetScrollInfo(sControl.Handle, SB_HORZ, SI);
  pXSize := SI.nPage; // -      

  SbInfo.cbSize := SizeOf(TScrollBarInfo);

  pXShift := 0;
  GetScrollBarInfo(sControl.Handle, Longint(OBJID_HSCROLL), SbInfo);
  if (SbInfo.rgstate[0] and STATE_SYSTEM_INVISIBLE) = 0 then
  begin
    if pRect.Right > pXSize then 
      pXShift := pRect.Right - pXSize
    else if pRect.Left < 0 then
      pXShift := pRect.Left; 
  end;

  SI.cbSize := Sizeof(SI);
  SI.fMask := SIF_ALL;
  GetScrollInfo(sControl.Handle, SB_VERT, SI);
  pYSize := SI.nPage; // -    .
  pYPos := SI.nPos; //   Y    .

//        .   Y --    
//   -      -       Y  LVM_SCROLL

  pYShift := 0;
  GetScrollBarInfo(sControl.Handle, Longint(OBJID_VSCROLL), SbInfo);
  if (SbInfo.rgstate[0] and STATE_SYSTEM_INVISIBLE) = 0 then
  begin
    if pRow < sControl.LVTopItem then
      pYShift := -((pYPos - pRow + 1) * pHeight)
	else if pRow > sControl.LVTopItem + pYSize - 1 then
      pYShift := (pRow - (sControl.LVTopItem + pYSize - 1)) * pHeight;
  end;

  SendMessage(sControl.Handle, LVM_SCROLL, pXShift, pYShift);
end;

procedure THIMST_UseEditCtrl.SetMSTControl;
begin
  if Value = nil then exit; 
  FMSTControl := Value;
  sControl := FMSTControl.ctrlpoint;
  FMSTControl.detachwndproc;
  
  OldMessage:= sControl.OnMessage;
  sControl.OnMessage := _OnMessage;
end;

procedure THIMST_UseEditCtrl._work_doSetData;
var
  dControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  dControl := _prop_MSTControl.ctrlpoint; 
  dControl.LVItems[NewLine, NewCurIdx] := ToString(_Data);
end;

procedure THIMST_UseEditCtrl._work_doSetCell;//test
var
  dControl: PControl;
begin
  NewLine := ReadInteger(_Data, _data_Row);
  NewCurIdx := ReadInteger(_Data, _data_Col);

  if not Assigned(_prop_MSTControl) then exit;
  dControl := _prop_MSTControl.ctrlpoint;

  dControl.Perform(US_ESCCELL, 0, 0);
  dControl.LVCurItem := NewLine;
  MakeVisible(NewLine, NewCurIdx);
  dControl.Perform(US_SETCELL, 0, 0)
end;

procedure THIMST_UseEditCtrl._work_doStop;
var
  dControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  dControl := _prop_MSTControl.ctrlpoint;
  dControl.Perform(US_ESCCELL, 0, 0);
end;

//     
//
procedure THIMST_UseEditCtrl._var_SubItem;
begin
  dtInteger(_Data, NewCurIdx);
end;

//      
//
procedure THIMST_UseEditCtrl._var_Cell;
var
  dControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  dControl := _prop_MSTControl.ctrlpoint; 
  dtString(_Data, dControl.LVItems[NewLine, NewCurIdx]);
end;

//    
//
procedure THIMST_UseEditCtrl._var_Index;
var
  sControl: PControl;
begin
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;
  dtInteger(_Data, sControl.CurIndex);
end;

//  
//
procedure THIMST_UseEditCtrl._var_Matrix;
begin
  if not Assigned(_prop_MSTControl) then exit;
  _prop_MSTControl.matrix(_Data);    
end;

procedure THIMST_UseEditCtrl._work_doClientRect;
var
  Row,Col: integer;
  R, ARect: TRect;
  dTop, dWidth, dHeight, Data: TData;
  b, s: integer;
  sControl: PControl;  

  function ScrollBarWidth(Style : Longint) : integer;
  begin
    Result := 0;
    if (GetWindowLong(sControl.Handle, GWL_STYLE) and Style) = 0 then exit;
    if Style = WS_VSCROLL then
      Result := GetSystemMetrics(SM_CXVSCROLL)
    else if Style = WS_HSCROLL then
      Result := GetSystemMetrics(SM_CYHSCROLL);
  end;

begin
  Row := ReadInteger(_Data, _data_Row);
  Col := ReadInteger(_Data, _data_Col);
  if not Assigned(_prop_MSTControl) then exit;
  sControl := _prop_MSTControl.ctrlpoint;
  
  R := sControl.LVSubItemRect(Row, Col);
  if Col = 0 then
  begin
    ARect := sControl.LVItemRect(Row, lvipLabel);
    R.Left := ARect.Left;
    R.Right := ARect.Right;
  end; 

	s := 0; b := 0;

    if fctl3d then
    begin
      case fwinstyle of
        0:
        begin
          s := 2; b := 3;
        end;
        1:
        begin
          s := 0; b := 1;
        end;
        2:
        begin
          s := 1; b := 2;
        end;
        3:
        begin
          s := 3; b := 4;
       end;
       4:
        begin
          s := 5; b := 6;
        end;
      end;
    end
    else
    begin
      s := 1; b := 1;
    end;

  if R.Left < sControl.Left then R.Left := sControl.Left - 1;
  dtInteger(Data, R.Left + sControl.Left + b + _prop_ShiftLeft);

  if (R.Right + b) >= sControl.Width - ScrollBarWidth(WS_VSCROLL) then  
    dtInteger(dWidth, sControl.Width - R.Left - 2 * b + 1 + _prop_AddWidth - ScrollBarWidth(WS_VSCROLL))
  else
    dtInteger(dWidth, R.Right - R.Left - 1 + _prop_AddWidth);

  dtInteger(dTop, R.Top + sControl.Top + s + _prop_ShiftTop);

  if (R.Bottom + s) >= sControl.Height - ScrollBarWidth(WS_HSCROLL) then  
    dtInteger(dHeight, sControl.Height - R.Top - 2 * s + _prop_AddHeight - ScrollBarWidth(WS_HSCROLL))
  else
    dtInteger(dHeight, R.Bottom - R.Top - 1 + _prop_AddHeight);

  Data.ldata:= @dTop;
  dTop.ldata:= @dWidth;
  dWidth.ldata:= @dHeight;

  _hi_OnEvent_(_event_onClientRect, Data);
end;

end.